﻿using System;
using KellermanSoftware.NetEmailValidation;
using KellermanSoftware.NetEmailValidationCoreDemo.Models;
using Microsoft.AspNetCore.Mvc;

namespace KellermanSoftware.NetEmailValidationCoreDemo.Controllers
{
    public class EmailValidationController : Controller
    {
        [HttpGet]
        public IActionResult Index()
        {
            return View();
        }        

        [HttpPost]
        public IActionResult Index(EmailViewModel model)
        {
            if (ModelState.IsValid)
            {
                EmailValidation validation;

                try
                {
                    validation = new EmailValidation(model.UserName, model.LicenseKey);
                }
                catch (Exception ex)
                {
                    model.Log = ex.Message;
                    ModelState.Clear();

                    return View(model);
                }

                
                validation.FromEmail = model.FromEmail;
                validation.FromMailServer = model.FromEmailServer;                           
                Result result = validation.ValidEmail(model.Email, validation.NoConnectOptions);                

                model.UserMessage = result.UserMessage;

                model.Log = result.Log;

                model.StatusDescription = result.StatusDescription;

                ModelState.Clear();

                return View(model);
            }

            return View();
        }
    }
}
