﻿using System;
using System.Windows.Forms;
using KellermanSoftware.NetEmailValidation;
using Microsoft.Win32;

namespace NetEmailValidationDemo
{
    public partial class frmRegister : Form
    {
        #region Declarations

        private RegistryKey _regKey;
        
        #endregion

        #region Properties

        #endregion

        #region Constructors

        public frmRegister()
        {
            InitializeComponent();

            _regKey = Registry.CurrentUser.CreateSubKey("Software\\KellermanSoftware\\EmailValidation");

        }

        #endregion

        #region Events

        private void RegisterForm_Load(object sender, EventArgs e)
        {
            txtUserName.Text = _regKey.GetValue("UserName", string.Empty).ToString();
            txtLicenseKey.Text = _regKey.GetValue("License", string.Empty).ToString();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            try
            {
                if (this.IsValid())
                {
                    EmailValidation emailValidation = new EmailValidation(txtUserName.Text, txtLicenseKey.Text);

                    _regKey.SetValue("UserName", txtUserName.Text, RegistryValueKind.String);
                    _regKey.SetValue("License", txtLicenseKey.Text, RegistryValueKind.String);

                    this.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "NET-Email-Validation-Demo", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        #endregion

        #region Methods

        private bool IsValid()
        {
            bool result = true;

            errorProvider1.SetError(txtUserName, string.Empty);
            errorProvider1.SetError(txtLicenseKey, string.Empty);

            if (string.IsNullOrEmpty(txtUserName.Text))
            {
                errorProvider1.SetError(txtUserName, "Please enter a value");
                result = false;
            }

            if (string.IsNullOrEmpty(txtLicenseKey.Text))
            {
                errorProvider1.SetError(txtLicenseKey, "Please enter a value");
                result = false;
            }

            return result;
        }

        #endregion

    }
}
