﻿Imports System
Imports System.Linq
Imports System.Windows.Forms
Imports KellermanSoftware.NetEmailValidation

Namespace NetEmailValidationSimpleDemo
	Partial Public Class frmMain
		Inherits Form

		Private _valid As EmailValidation

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub btnValidate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnValidate.Click
			If Not ValidateControls() Then
				Return
			End If

			_valid.FromMailServer = txtFromEmailServer.Text
			_valid.FromEmail = txtFromEmail.Text
			Dim myResult As Result = _valid.ValidEmail(txtEmailAddress.Text,_valid.BestConnectionOptions())

			txtLog.Text = myResult.Log

			If myResult.IsValid Then
				MessageBox.Show(myResult.UserMessage, "Valid Email", MessageBoxButtons.OK, MessageBoxIcon.Question)
			Else
				MessageBox.Show(myResult.UserMessage, "Invalid Email", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
			End If
		End Sub

		Private Sub frmMain_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
			Try
				'This is trial mode
				_valid = New EmailValidation()

				'Example of licensed mode
				'_valid = new EmailValidation("place user name here from your receipt", "place license key here from your receipt"); 
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Function ValidateControls() As Boolean
			Dim result As Boolean = True
'INSTANT VB NOTE: The variable controls was renamed since Visual Basic does not handle local variables named the same as class members well:
			Dim controls_Renamed = { txtFromEmailServer, txtFromEmail, txtEmailAddress }
			For Each control In controls_Renamed.Where(Function(c) String.IsNullOrEmpty(c.Text))
				' clear previous errors
				errorProvider.SetError(control, "")
			Next control
			errorProvider.Clear()
			For Each control In controls_Renamed.Where(Function(c) String.IsNullOrEmpty(c.Text))
				errorProvider.SetError(control, "Please fill the required field")
				result = False
			Next control
			Return result
		End Function
	End Class
End Namespace